﻿/**
 * SRM P4 cutter
 *
 * 0x000 - 0x7ff ファイル情報(16byte)の羅列
 * 0x800 -       実データ
 *
 * ファイル情報
 * +00 : ファイル名(10byte)
 * +0A : ファイル長(2byte)
 * +0E : オフセット(4byte) 実際のオフセットは+0x800
 *
 */

import std.stdio;
import std.string;
import std.stream;

uint get_dword(byte[] p_in)
{
  return (
      ((p_in[0] << 24) & 0xff000000) +
      ((p_in[1] << 16) & 0xff0000) +
      ((p_in[2] <<  8) & 0xff00) +
       (p_in[3]        & 0xff)
      );
}

ushort get_word(byte[] p_in)
{
    return (
        ((p_in[0] <<  8) & 0xff00) +
         (p_in[1]        & 0xff)
        );
}

void cutter(char[] name, byte[] input, ulong input_size)
{
  uint read_ofs;			// file size info offset
  ushort data_size;			// file data size
  ushort data_ofs = 0x800;	// file data offset
  int i = 0;
  char fnamez[11];

  writefln("Name        Size   Offset");
  writefln("--------------------------");

  // 展開
  do {
	  for (int j=0; j < 0x0a; j++) {
		fnamez[j] = input[(i*0x10) + j];
	  }
	  fnamez[0x0a] = 0x00;

	  if (fnamez[0x00] == 0x00) {
		  break;
	  }

	  data_size = get_word(input[(i*0x10)+0x0a..(i*0x10)+0x0c]);
	  data_ofs  = get_dword(input[(i*0x10)+0x0c..(i*0x10)+0x10]) + 0x800;
      writefln("%s 0x%04x 0x%04x", fnamez, data_size, data_ofs);

    if (data_size) {
//      writefln("%s - %5d byte", fnamez, data_size);
      File outp = new File(fnamez, FileMode.OutNew);
      if (outp) {
        outp.writeExact(&input[data_ofs], data_size);
        delete outp;
      }
      data_ofs += data_size;

      i++;
    }
  } while(data_size && i < 0x80);
}

void usage(char[] name)
{
  writefln("usage: %s [filename]", name);
}

int main (char[][] args)
{
  if (args.length == 1) {
    usage(args[0]);
  }

  foreach (arg; args[1 .. args.length]) {
    try {
      auto input_size = std.file.getSize(arg);
      byte[] input = cast(byte[])std.file.read(arg);
      cutter(arg, input, input_size);
    } catch(Exception e) {
      writefln("catch %s", e.msg);
    }
  }
  return 0;
}
